# voxelcloud-utils

[![NPM package][npm-version-image]][npm-url]
[![NPM downloads][npm-downloads-image]][npm-url]
[![MIT License][license-image]][license-url]
[![Test workflow][workflow-image]][workflow-url]
[![Coverage Status][coveralls-image]][coveralls-url]

collection of multiple utility function like `lodash`, also includes HTTP request library `voxios` based on `axios`.

> docs website [click here](https://harrychen0506.github.io/vc-utils/)

### Features

#### util

- [x] cloneDeep
- [x] isEmpty
- [x] isPlainObject
- [x] throttle
- [x] debounce
- [x] groupBy
- [x] uuid

#### data

- [x] Enum
- [x] storage
- [x] Session

#### browser

- [x] copyToClipboard

#### request

- [x] Voxios

### Usage

- Install

```bash
yarn add voxelcloud-utils
```

- Usage

```javascript
import { cloneDeep } from 'voxelcloud-utils';

console.log(cloneDeep({ name: 'voxelcloud' }));
```

### Development

- Dev

```bash
yarn install
npm run dev
```

- Code Commit

```bash
npm run commit
```

### Release

1.  Create Standard Version

```bash
# 注意以下命令需选择：
npm run release # 默认补丁版本 增加0.0.1
npm run release -- --first-release # 首次发布
npm run release -- --prerelease # 预发布 This will tag your version as: 1.0.1-0
npm run release -- --prerelease alpha # This will tag the version as: 1.0.1-alpha.0
npm run release -- --release-as major # 主版本变更
npm run release -- --release-as minor # 次级版本变更
npm run release -- --release-as patch # 补丁版本变更
npm run release -- --release-as 1.1.0 # 变更指定版本
```

2. Build

```bash
npm run build
```

3. Npm Publish

```bash
git push --follow-tags origin [branchName] # branchName 分支名
npm publish
```

[npm-version-image]: https://img.shields.io/npm/v/voxelcloud-utils.svg
[npm-downloads-image]: http://img.shields.io/npm/dm/voxelcloud-utils.svg?style=flat
[npm-url]: https://www.npmjs.com/package/voxelcloud-utils
[workflow-image]: https://github.com/voxelcloud/vc-utils/actions/workflows/test.yml/badge.svg
[workflow-url]: https://github.com/voxelcloud/vc-utils/actions/workflows/test.yml
[coveralls-image]: https://coveralls.io/repos/github/HarryChen0506/vc-utils/badge.svg?branch=dev-chenwenhua
[coveralls-url]: https://coveralls.io/github/HarryChen0506/vc-utils?branch=dev-chenwenhua
[license-image]: http://img.shields.io/badge/license-MIT-blue.svg?style=flat
[license-url]: LICENSE
