import React from 'react';
import axios from 'axios';
import { compile } from 'path-to-regexp';
import { stringify } from 'qs';

var index = (function (_ref) {
  var title = _ref.title;
  return /*#__PURE__*/React.createElement("h1", null, title);
});

function ownKeys(object, enumerableOnly) {
  var keys = Object.keys(object);

  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);

    if (enumerableOnly) {
      symbols = symbols.filter(function (sym) {
        return Object.getOwnPropertyDescriptor(object, sym).enumerable;
      });
    }

    keys.push.apply(keys, symbols);
  }

  return keys;
}

function _objectSpread2(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};

    if (i % 2) {
      ownKeys(Object(source), true).forEach(function (key) {
        _defineProperty(target, key, source[key]);
      });
    } else if (Object.getOwnPropertyDescriptors) {
      Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
    } else {
      ownKeys(Object(source)).forEach(function (key) {
        Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
      });
    }
  }

  return target;
}

function _typeof(obj) {
  "@babel/helpers - typeof";

  if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
    _typeof = function (obj) {
      return typeof obj;
    };
  } else {
    _typeof = function (obj) {
      return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
    };
  }

  return _typeof(obj);
}

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;

  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }

  return target;
}

function _objectWithoutProperties(source, excluded) {
  if (source == null) return {};

  var target = _objectWithoutPropertiesLoose(source, excluded);

  var key, i;

  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);

    for (i = 0; i < sourceSymbolKeys.length; i++) {
      key = sourceSymbolKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
      target[key] = source[key];
    }
  }

  return target;
}

function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest();
}

function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

function _iterableToArrayLimit(arr, i) {
  var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"];

  if (_i == null) return;
  var _arr = [];
  var _n = true;
  var _d = false;

  var _s, _e;

  try {
    for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);

      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null) _i["return"]();
    } finally {
      if (_d) throw _e;
    }
  }

  return _arr;
}

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;

  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];

  return arr2;
}

function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

var cloneDeep = function cloneDeep(obj) {
  // Handle the 3 simple types, and null or undefined
  if (obj === null || _typeof(obj) !== 'object') return obj; // Handle Date

  if (obj instanceof Date) {
    var _copy = new Date();

    _copy.setTime(obj.getTime());

    return _copy;
  } // Handle Array


  if (obj instanceof Array) {
    var _copy2 = [];
    var len = obj.length;

    for (var i = 0; i < len; ++i) {
      _copy2[i] = cloneDeep(obj[i]);
    }

    return _copy2;
  } // Handle Moment


  if (obj._isAMomentObject) {
    return obj.clone();
  } // Handle Object


  var copy = {};

  for (var attr in obj) {
    if (Object.prototype.hasOwnProperty.call(obj, attr)) {
      copy[attr] = cloneDeep(obj[attr]);
    }
  }

  return copy;
};

var compose = function compose() {
  for (var _len = arguments.length, funcs = new Array(_len), _key = 0; _key < _len; _key++) {
    funcs[_key] = arguments[_key];
  }

  if (funcs.length === 0) {
    return function (arg) {
      return arg;
    };
  }

  if (funcs.length === 1) {
    return funcs[0];
  }

  return funcs.reduce(function (a, b) {
    return function () {
      return a(b.apply(void 0, arguments));
    };
  });
};

/**
 * 判断数据是否为空, 包括 空字符串，空数组， 空对象，null，undefined
 * @param {*} obj
 * @returns {boolean}
 */
var isEmpty = function isEmpty(obj) {
  if (obj === null || obj === undefined || obj === '') {
    return true;
  }

  if (Array.isArray(obj)) {
    return obj.length === 0;
  }

  return obj.constructor === Object && Object.keys(obj).length === 0;
};

function isPlainObject(target) {
  return target !== null && _typeof(target) === 'object' && target.constructor === Object;
}

function throttle(func) {
  var wait = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 166;
  var timerId;
  var startTime = Date.now();
  return function () {
    var curTime = Date.now();
    var remaining = wait - (curTime - startTime);
    var context = this;
    var args = arguments;
    clearTimeout(timerId);

    if (remaining <= 0) {
      func.apply(context, Array.from(args));
      startTime = Date.now();
    } else {
      timerId = setTimeout(function () {
        func.apply(context, Array.from(args));
      }, remaining);
    }
  };
}

function debounce(func) {
  var wait = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 166;
  var timerId;

  function debounced() {
    var _this = this;

    var args = arguments;

    var later = function later() {
      func.apply(_this, Array.from(args));
    };

    clearTimeout(timerId);
    timerId = setTimeout(later, wait);
  }

  debounced.clear = function () {
    clearTimeout(timerId);
  };

  return debounced;
}

/**
 * 分组函数
 * input : [{name: 'a', age: 1}, {name: 'b', age: 2}]
 * func: (item, index, target) => item.name
 * output: [['a', [{name: 'a', age: 1}]], [['b', [{name: 'b', age: 2}]]]]
 * @param {Array} target
 * @param {function} func
 * @returns {Array} 二维数组 Array<[any, T[]]>
 */
var groupBy = function groupBy() {
  var target = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
  var func = arguments.length > 1 ? arguments[1] : undefined;
  var category = new Map();
  target.forEach(function (item, index, array) {
    var key = func(item, index, array);

    if (category.has(key) && Array.isArray(category.get(key))) {
      category.get(key).push(item);
    } else {
      category.set(key, [item]);
    }
  });
  var result = [];
  category.forEach(function (value, key) {
    result.push([key, value]);
  });
  return result;
};

var uuid = function uuid() {
  var s = [];
  var hexDigits = '0123456789abcdef';

  for (var i = 0; i < 36; i++) {
    s[i] = hexDigits.substr(Math.floor(Math.random() * 0x10), 1);
  }

  s[14] = '4'; // bits 12-15 of the time_hi_and_version field to 0010

  var k = Number(s[19]) & 0x3 | 0x8;
  s[19] = hexDigits.substr(k, 1); // bits 6-7 of the clock_seq_hi_and_reserved to 01

  s[8] = s[13] = s[18] = s[23] = '-';
  var uuid = s.join('');
  return uuid;
};

/**
 * 复制到剪切板
 * @param {String} text
 * @returns {Promise} Promise<IReturn>
 */
var copyToClipboard = function copyToClipboard(text) {
  return new Promise(function (resolve, reject) {
    // const span = document.createElement('span');
    // span.style.position = 'fixed';
    // span.style.top = '0';
    // span.style.left = '0';
    // span.style.width = '0';
    // span.style.height = '0';
    // span.innerText = text;
    // document.body.appendChild(span);
    // try {
    //   const range = document.createRange();
    //   range.selectNodeContents(span);
    //   const selection = window.getSelection();
    //   selection!.removeAllRanges();
    //   selection!.addRange(range);
    //   document.execCommand('copy');
    //   resolve({
    //     success: true,
    //     message: 'ok',
    //   });
    // } catch (err) {
    //   reject({
    //     success: false,
    //     message: err.message || 'fail',
    //   });
    // } finally {
    //   document.body.removeChild(span);
    // }
    var input = document.createElement('textarea');
    input.style.position = 'fixed';
    input.style.top = '0';
    input.style.left = '0';
    input.style.width = '0';
    input.style.height = '0';
    input.style.opacity = '0';
    input.setAttribute('value', text);
    input.value = text;
    document.body.appendChild(input);
    input.select();

    try {
      document.execCommand('copy');
      resolve({
        success: true,
        message: 'ok'
      });
    } catch (err) {
      reject({
        success: false,
        message: (err === null || err === void 0 ? void 0 : err.message) || 'fail'
      });
    } finally {
      document.body.removeChild(input);
    }
  });
};

/**
 * 枚举定义类
 * 示例：
 * const STATUS = createEnum({
 *     WAIT: [1, '审核中', 'status.wait'],
 *     PASS: [2, '审核通过', 'status.pass']
 * })
 * 标识符 -> [枚举值, 描述, 国际化]
 * 获取枚举值：STATUS.WAIT 或 STATUS.getValue('WAIT')
 * 获取枚举描述：STATUS.getDesc('WAIT')
 * 通过枚举值获取描述：STATUS.getDescByValue(1)
 * 通过枚举值获取国际化id：STATUS.getIntlByValue(1)
 * 获取选项：STATUS.getOptions()
 * @param {object} definition
 */
var Enum = /*#__PURE__*/function () {
  function Enum() {
    var _this = this;

    var definition = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, Enum);

    this._definition = {};
    this._nameToValueMap = {};
    this._valueToDescMap = new Map();
    this._valueToIntlMap = new Map();
    this._definition = definition;
    Object.keys(definition).forEach(function (key) {
      var _definition$key = _slicedToArray(definition[key], 3),
          value = _definition$key[0],
          desc = _definition$key[1],
          intl = _definition$key[2];

      _this._nameToValueMap[key] = value;

      _this._valueToDescMap.set(value, desc);

      _this._valueToIntlMap.set(value, intl);
    });
    Object.assign(this, this._nameToValueMap);
  }

  _createClass(Enum, [{
    key: "getNames",
    value: function getNames() {
      return Object.keys(this._nameToValueMap);
    }
  }, {
    key: "getKeys",
    value: function getKeys() {
      return Object.keys(this._nameToValueMap);
    }
  }, {
    key: "getValue",
    value: function getValue(name) {
      return this._nameToValueMap[name];
    }
  }, {
    key: "getValues",
    value: function getValues() {
      return Object.values(this._nameToValueMap);
    }
  }, {
    key: "getNameByValue",
    value: function getNameByValue(value) {
      var _this2 = this;

      return Object.keys(this._nameToValueMap).find(function (v) {
        return _this2._nameToValueMap[v] === value;
      });
    }
  }, {
    key: "getDesc",
    value: function getDesc(name) {
      return this._definition[name] && this._definition[name][1];
    }
  }, {
    key: "getDescByValue",
    value: function getDescByValue(value) {
      return this._valueToDescMap.get(value);
    }
  }, {
    key: "getIntl",
    value: function getIntl(name) {
      return this._definition[name] && this._definition[name][2];
    }
  }, {
    key: "getIntlByValue",
    value: function getIntlByValue(value) {
      return this._valueToIntlMap.get(value);
    }
  }, {
    key: "getOptions",
    value: function getOptions() {
      var _this3 = this;

      return Object.keys(this._definition).map(function (v) {
        return {
          name: v,
          key: v,
          value: _this3[v],
          desc: _this3.getDesc(v)
        };
      });
    }
  }]);

  return Enum;
}();

var createEnum = function createEnum(definition) {
  return new Enum(definition);
};

var formatSavedTarget = function formatSavedTarget(value) {
  if (typeof value === 'string' || typeof value === 'number' || typeof value === 'boolean') {
    return value;
  }

  if (value instanceof Date) {
    return value.toString();
  }

  try {
    return JSON.stringify(value);
  } catch (e) {
    return value;
  }
};

var formatReturnedTarget = function formatReturnedTarget(value) {
  try {
    return JSON.parse(value);
  } catch (e) {
    return value;
  }
};

var localStorage = {
  save: function save(key, value) {
    var target = formatSavedTarget(value);
    return window.localStorage.setItem(key, target);
  },
  get: function get(key) {
    var orginValue = window.localStorage.getItem(key);
    return formatReturnedTarget(orginValue);
  },
  getOrigin: function getOrigin(key) {
    return window.localStorage.getItem(key);
  },
  remove: function remove(key) {
    return window.localStorage.removeItem(key);
  },
  canSupport: function canSupport() {
    return window && _typeof(window.localStorage) === 'object';
  }
};
var sessionStorage = {
  save: function save(key, value) {
    var target = formatSavedTarget(value);
    return window.sessionStorage.setItem(key, target);
  },
  get: function get(key) {
    var orginValue = window.sessionStorage.getItem(key);
    return formatReturnedTarget(orginValue);
  },
  getOrigin: function getOrigin(key) {
    return window.sessionStorage.getItem(key);
  },
  remove: function remove(key) {
    return window.sessionStorage.removeItem(key);
  },
  canSupport: function canSupport() {
    return window && _typeof(window.sessionStorage) === 'object';
  }
};
var globalState = {};
var globalStorage = {
  save: function save(key, value) {
    return globalState[key] = value;
  },
  get: function get(key) {
    return globalState[key];
  },
  remove: function remove(key) {
    return delete globalState[key];
  },
  getState: function getState() {
    return globalState;
  },
  canSupport: function canSupport() {
    return true;
  }
};
var getStorage = function getStorage(type) {
  if (type === 'localStorage') {
    return localStorage;
  }

  if (type === 'sessionStorage') {
    return sessionStorage;
  }

  if (type === 'globalStorage') {
    return globalStorage;
  }

  return [localStorage, sessionStorage, globalStorage].find(function (v) {
    return typeof v.canSupport === 'function' && v.canSupport();
  });
};
var storageUtils = {
  formatSavedTarget: formatSavedTarget,
  formatReturnedTarget: formatReturnedTarget
};

var DEFAULT_SESSION_NAME = 'token';

var Session = /*#__PURE__*/function () {
  function Session() {
    var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
        name = _ref.name,
        getStorage$1 = _ref.getStorage;

    _classCallCheck(this, Session);

    this.sessionName = DEFAULT_SESSION_NAME;
    this.getStorage = void 0;

    if (name) {
      this.sessionName = name;
    }

    this.getStorage = typeof getStorage$1 === 'function' ? getStorage$1 : getStorage;
  }

  _createClass(Session, [{
    key: "saveToken",
    value: function saveToken(data) {
      var storage = this.getStorage();
      var key = this.sessionName;
      storage.save(key, data);
    }
  }, {
    key: "getToken",
    value: function getToken() {
      var storage = this.getStorage();
      var key = this.sessionName;
      var res = storage.get(key);
      return res === null ? '' : res;
    }
  }, {
    key: "removeToken",
    value: function removeToken() {
      var storage = this.getStorage();
      var key = this.sessionName;
      storage.remove(key);
    }
  }, {
    key: "save",
    value: function save(token) {
      if (!isEmpty(token)) {
        this.saveToken(token);
      }

      return this;
    }
  }, {
    key: "get",
    value: function get() {
      return this.getToken();
    }
  }, {
    key: "clear",
    value: function clear() {
      this.removeToken();
      return this;
    }
  }]);

  return Session;
}();

var _excluded = ["url", "method", "data", "params", "headers", "axiosConfig", "otherConfig"];
var transformRequestOptions = function transformRequestOptions() {
  var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {
    url: '',
    method: 'get'
  };
  var config = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

  var _options$url = options.url,
      url = _options$url === void 0 ? '' : _options$url,
      _options$method = options.method,
      method = _options$method === void 0 ? 'get' : _options$method,
      data = options.data,
      params = options.params,
      headers = options.headers,
      axiosConfigFromOptions = options.axiosConfig,
      otherConfigFromOptions = options.otherConfig,
      restOptions = _objectWithoutProperties(options, _excluded);

  var axiosConfigFromConfig = config.axiosConfig,
      wxConfigFromConfig = config.wxConfig;

  var finalAxiosConfig = _objectSpread2(_objectSpread2({}, axiosConfigFromConfig), axiosConfigFromOptions);

  var finalOtherConfig = _objectSpread2(_objectSpread2({}, wxConfigFromConfig), otherConfigFromOptions);

  var newUrl = url;

  try {
    var domain = '';

    if (newUrl.match(/[a-zA-z]+:\/\/[^/]*/)) {
      var _ref = newUrl.match(/[a-zA-z]+:\/\/[^/]*/) || [];

      var _ref2 = _slicedToArray(_ref, 1);

      var _ref2$ = _ref2[0];
      domain = _ref2$ === void 0 ? '' : _ref2$;
      newUrl = url.slice(domain.length);
    }

    newUrl = compile(newUrl, {
      encode: encodeURIComponent
    })(params);
    newUrl = domain + newUrl;
  } catch (e) {
    // eslint-disable-next-line no-console
    console.error('voxios compile url params fail!', e, options);
  }

  var newOptions = _objectSpread2(_objectSpread2({}, restOptions), {}, {
    method: method.toLowerCase(),
    headers: headers,
    data: data
  });

  if (newOptions.method === 'get') {
    newOptions.params = data;
  }

  return _objectSpread2(_objectSpread2(_objectSpread2({
    url: newUrl
  }, newOptions), finalAxiosConfig), finalOtherConfig);
};
var defaultAxiosRequest = function defaultAxiosRequest(options, config, context) {
  var _ref3 = config || {},
      onSuccess = _ref3.onSuccess,
      onError = _ref3.onError,
      normalizeError = _ref3.normalizeError;

  if (options.method === 'get') {
    delete options.data;
  }

  return axios(options).then(function (res) {
    var _res$data = res.data,
        data = _res$data === void 0 ? {} : _res$data,
        status = res.status;

    if (_typeof(data) === 'object') {
      data.httpCode = status;
    }

    return res;
  }).then(function (res) {
    if (typeof onSuccess === 'function') {
      return onSuccess(res, context);
    }

    return res;
  }).catch(function (error) {
    if (typeof onError === 'function') {
      onError(error, context);
    }

    if (typeof normalizeError === 'function') {
      throw normalizeError(error);
    }

    throw error;
  });
};
var createInstance = function createInstance() {
  var config = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var context = arguments.length > 1 ? arguments[1] : undefined;
  return function () {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {
      url: '',
      method: 'get'
    };

    var mergedConfig = _objectSpread2(_objectSpread2({}, config), options.config);

    var requestOptions = transformRequestOptions(options, mergedConfig);
    var instanceContext = Object.assign(context, {
      config: mergedConfig,
      options: requestOptions
    });
    var onBeforeRequest = mergedConfig.onBeforeRequest,
        addHeader = mergedConfig.addHeader,
        transformHeaders = mergedConfig.transformHeaders;

    if (typeof addHeader === 'function') {
      requestOptions.headers = _objectSpread2(_objectSpread2({}, requestOptions.headers), addHeader(requestOptions.headers));
    }

    if (typeof transformHeaders === 'function') {
      requestOptions.headers = transformHeaders(requestOptions.headers);
    }

    if (typeof onBeforeRequest === 'function') {
      onBeforeRequest(instanceContext);
    }

    if (typeof mergedConfig.request === 'function') {
      return mergedConfig.request(requestOptions, mergedConfig, instanceContext);
    }

    return defaultAxiosRequest(requestOptions, mergedConfig, instanceContext);
  };
};

var baseConfig = {
  isSuccess: function isSuccess(response) {
    var status = response.status;

    if (status === 200) {
      return true;
    }

    return false;
  }
};

function create(instanceConfig, context) {
  return createInstance(_objectSpread2(_objectSpread2({}, baseConfig), instanceConfig), context);
}

var Voxios = /*#__PURE__*/function () {
  function Voxios() {
    _classCallCheck(this, Voxios);

    this.info = 'voxios is an axios-like request util';
    this.state = void 0;
    this.instance = void 0;
    this.state = {
      currentConfig: {},
      module: {}
    };
    this.createInstance();
  }

  _createClass(Voxios, [{
    key: "createInstance",
    value: function createInstance() {
      var currentConfig = this.state.currentConfig;
      this.instance = create(currentConfig, this);
    }
  }, {
    key: "getInstance",
    value: function getInstance() {
      return this.instance;
    }
  }, {
    key: "addModule",
    value: function addModule(key, value) {
      var module = this.state.module;
      module[key] = value;
      return this;
    }
  }, {
    key: "removeModule",
    value: function removeModule(key) {
      var module = this.state.module;
      delete module[key];
      return this;
    }
  }, {
    key: "getModule",
    value: function getModule(key) {
      var module = this.state.module;
      return module[key];
    }
  }, {
    key: "setConfig",
    value: function setConfig(config) {
      this.state.currentConfig = config;
      this.createInstance();
      return this;
    }
  }, {
    key: "registerConfig",
    value: function registerConfig(key, value) {
      Voxios.registerConfig(key, value);
      return this;
    }
  }, {
    key: "useConfig",
    value: function useConfig(name) {
      var configMap = Voxios.configMap;
      this.setConfig(configMap[name]);
      return this;
    }
  }, {
    key: "updateConfig",
    value: function updateConfig(updater) {
      if (typeof updater !== 'function') {
        // console.warn('Voxios updateConfig params should be a function');
        return this;
      }

      var newConfig = updater(this.state.currentConfig);
      return this.setConfig(newConfig);
    }
  }, {
    key: "useDefaultConfig",
    value: function useDefaultConfig() {
      return this.useConfig('default');
    }
  }], [{
    key: "registerConfig",
    value: function registerConfig(key, value) {
      var configMap = Voxios.configMap;
      configMap[key] = value;
    }
  }, {
    key: "unregisterConfig",
    value: function unregisterConfig(key) {
      var configMap = Voxios.configMap;
      delete configMap[key];
    }
  }]);

  return Voxios;
}();

Voxios.core = {
  create: create,
  createInstance: createInstance
};
Voxios.configMap = {
  default: {}
};

var ERROR_CODE = 'error_code';
var defaultConfig = {
  throwErrorMessage: true,
  addHeader: function addHeader() {
    return {};
  },
  transformHeaders: function transformHeaders(headers) {
    return headers;
  },
  axiosConfig: {
    paramsSerializer: function paramsSerializer(params) {
      return stringify(params, {
        arrayFormat: 'repeat'
      });
    }
  },
  isSuccess: function isSuccess(response) {
    var status = response.status;

    if (status === 200) {
      return true;
    }

    return false;
  },
  getErrorCode: function getErrorCode(response) {
    var _ref = response || {},
        _ref$data = _ref.data,
        data = _ref$data === void 0 ? {} : _ref$data;

    return data[ERROR_CODE];
  },
  onSuccess: function onSuccess(res, context) {
    var _options$config, _options$config2;

    var options = context.options,
        config = context.config;
    var isSuccess = (options === null || options === void 0 ? void 0 : (_options$config = options.config) === null || _options$config === void 0 ? void 0 : _options$config.isSuccess) || config.isSuccess;
    var getErrorCode = (options === null || options === void 0 ? void 0 : (_options$config2 = options.config) === null || _options$config2 === void 0 ? void 0 : _options$config2.getErrorCode) || config.getErrorCode;
    var _res$data = res.data,
        data = _res$data === void 0 ? {} : _res$data;

    if (typeof isSuccess === 'function' && isSuccess(res)) {
      if (_typeof(data) === 'object') {
        data.statusText = 'OK';
      }

      return data;
    }

    var error = {
      code: typeof getErrorCode === 'function' && getErrorCode(res),
      message: data.message || data.msg || data.errmsg,
      data: data,
      origin: res
    };
    return Promise.reject(error);
  },
  onError: function onError(error, context) {
    var _options$config3, _options$config4;

    var options = context.options,
        config = context.config;
    var showErrorMessage = Boolean((options === null || options === void 0 ? void 0 : (_options$config3 = options.config) === null || _options$config3 === void 0 ? void 0 : _options$config3.throwErrorMessage) || (config === null || config === void 0 ? void 0 : config.throwErrorMessage));
    var normalizeError = (options === null || options === void 0 ? void 0 : (_options$config4 = options.config) === null || _options$config4 === void 0 ? void 0 : _options$config4.normalizeError) || (config === null || config === void 0 ? void 0 : config.normalizeError);
    var threwError = error;

    if (typeof error === 'string') ; else if (_typeof(error) === 'object' && error !== null && error.response) {
      var response = error.response;

      if (response && response.status) {
        var errorText = response.statusText;
        var status = response.status,
            data = response.data;
      }

      if (typeof normalizeError === 'function') {
        threwError = normalizeError(error);
      }
    }

    if (showErrorMessage) {
      var onThrowError = context.getModule('onThrowError');
      typeof onThrowError === 'function' && onThrowError(threwError);
    }
  },
  normalizeError: function normalizeError(error) {
    if (!error || !error.response) {
      return error;
    }

    var response = error.response;
    var data = response.data,
        status = response.status;

    if (typeof data === 'string') {
      data = {
        data: data
      };
    }

    return {
      code: data[ERROR_CODE],
      message: data.message,
      data: _objectSpread2(_objectSpread2({}, data), {}, {
        httpCode: status
      }),
      origin: response,
      error: error
    };
  }
};

var voxios = {
  Voxios: Voxios,
  defaultConfig: defaultConfig
};

export { Enum, index as Foo, Session, Voxios, cloneDeep, compose, copyToClipboard, createEnum, debounce, getStorage, globalStorage, groupBy, isEmpty, isPlainObject, localStorage, sessionStorage, storageUtils, throttle, uuid, voxios, defaultConfig as voxiosDefaultConfig };
