export interface IFunc<T> {
    (item: T, index: number, array: Array<T>): any;
}
export declare type TReturn<T> = Array<[any, T[]]>;
/**
 * 分组函数
 * input : [{name: 'a', age: 1}, {name: 'b', age: 2}]
 * func: (item, index, target) => item.name
 * output: [['a', [{name: 'a', age: 1}]], [['b', [{name: 'b', age: 2}]]]]
 * @param {Array} target
 * @param {function} func
 * @returns {Array} 二维数组 Array<[any, T[]]>
 */
declare const groupBy: <T>(target: T[] | undefined, func: IFunc<T>) => TReturn<T>;
export default groupBy;
