export declare type sessionData = string | number;
export interface IConfig {
    name?: string;
    getStorage?(): any;
    [propName: string]: any;
}
export interface ISession {
    saveToken(data: sessionData): void;
    getToken(): any;
    removeToken(): void;
    save(data: sessionData): ISession;
    get(): ISession;
    clear(): ISession;
}
declare class Session implements ISession {
    readonly sessionName: string;
    readonly getStorage: (() => any) | ((type?: import("../storage").StorageType | undefined) => import("../storage").ILocalStorage | import("../storage").IGlobalStorage | undefined);
    constructor({ name, getStorage: getStorage }?: IConfig);
    saveToken(data: sessionData): void;
    getToken(): any;
    removeToken(): void;
    save(token: sessionData): this;
    get(): any;
    clear(): this;
}
export default Session;
