import { IVoxios, IConfig, IVoxiosState, IVoxiosInstance, IConfigUpdater } from './type';
declare function create(instanceConfig: IConfig, context: IVoxios): any;
declare class Voxios implements IVoxios {
    info: string;
    state: IVoxiosState;
    instance: IVoxiosInstance;
    static core: {
        create: typeof create;
        createInstance: (config: IConfig | undefined, context: IVoxios) => import("./type").ICreateRequest;
    };
    static configMap: {
        default: {};
    };
    static registerConfig(key: string, value: IConfig): void;
    static unregisterConfig(key: string): void;
    constructor();
    createInstance(): void;
    getInstance(): import("./type").ICreateRequest;
    addModule(key: string, value: any): this;
    removeModule(key: string): this;
    getModule(key: string): any;
    setConfig(config: IConfig): this;
    registerConfig(key: string, value: IConfig): this;
    useConfig(name: string): this;
    updateConfig(updater: IConfigUpdater): this;
    useDefaultConfig(): this;
}
export default Voxios;
